'*****************************  ISR  *****************************************

#if Network = 1
   'INT2 Interrupt
   Isr_int2:                                                'Paket am Ethernet-Chip eingetroffen
      ' LED BLINKEN LASSEN
      Data_present = 1
   Return

   Sub Dhcp_received_newip                                     'Neue IPerhalten
      Locate 15 , 1
      Lcd "DHCP-IP: " ; Myip(1) ; "." ; Myip(2) ; "." ; Myip(3) ; "." ; Myip(4)
   End Sub
#endif

'Timer1 Interrupt
Timer1_isr:                                                 'Sekundenintervall
   Incr L2
   Set Lcd_refresh
Return

'TxD Complete Interrupt
Dmxsend:                                                    'Neues DMX512-Paket zusammenstellen
   If Dmxstate = 0 Then
      Dmxstate = 1
      Ubrr = 10                                             '90,9kBaud
'      $baud = 9090
      Udr = 0                                               'send Break
   Elseif Dmxstate = 1 Then
      Dmxstate = 2
      Curdmxch = 0
      Ubrr = 3                                              '250kBaud
'      $baud = 250000
      Udr = 0                                               'send Startbyte
   Else
      Curdmxch = Curdmxch + 1
      Waitus 30                                             'InterByteGap-Zeit - Standard ist 10s
      Udr = Dmxfield(curdmxch)                              'DMX-Wert des aktuellen Kanals senden
      If Curdmxch = Lastchan Then
         Dmxstate = 0                                       'neuer Break, wenn alle Kanle gesendet worden sind
      End If
   End If
Return

'Timer2 Interrupt
Dimmerkernel:                                               'Millisekundenintervall
   Timer2 = 125                                             ' Timer-Interrupt jede ms ausfhren (16000000MHz/128/125=1000kHz)

   For I = 1 To Lastchan
      If Dmxfield(i) < Newdmxfield(i) Then
         If Curdmxsteps(i) < Dmxsteps(i) Then
            Incr Curdmxsteps(i)
         Else
            ' nach oben dimmen
            Curdmxsteps(i) = 0
            Incr Dmxfield(i)
         End If
      Elseif Dmxfield(i) > Newdmxfield(i) Then
         If Curdmxsteps(i) < Dmxsteps(i) Then
            Incr Curdmxsteps(i)
         Else
            ' nach oben dimmen
            Curdmxsteps(i) = 0
            Decr Dmxfield(i)
         End If
      End If
   Next
Return