' Routine to get the NetWork Time from a time-server'

'#####################################################################################################################
' Folgende nderungen wurden gemacht:
'
' Neue Prozedur Ntp_dst_correction
' (muss natrlich noch an geeigneter Stelle deklariert werden)
'
' Am Ende von NTP get
'   Buffer(43) = &HD9
'   Buffer(44) = &H00                                        data for ntp request
'   Buffer(45) = &H0A
'   Buffer(46) = &HFA
'   Buffer(52) = &H01
'   Buffer(53) = &H04
' ersetzt durch
' Buffer(43)                                                 00 Leap indicator, 011 Version3, 011 Mode=Client
' (keine Ahnung, wie Ben (?) auf diese Werke gekommen ist, eigentlich ist nur das Flag-Byte ntig )
'
'      Call Echopacket
' ersetzt durch
'      Call Enc28j60packetsend(90)
' (Wir wissen ja schon,wie lang das Paket sein soll)
'
' Die Zeit wird aus Buffer 83-86 (Transmit Time Stamp) entnommen, bisher war es 59-62 (Reference Clock Update Time)
'
' Ausserdem ist eine nderung in der variables.inc unter "for NTP-routine" ntig:
' Dim S(4) As Byte                <--- kann entfallen, ich arbeite direkt in Buffer, da der Inhalt sowieso nicht mehr bentigt wird
' Dim L1 As Long At S Overlay     <--- muss gendert werden in:    Dim L1 As Long At buffer(83) Overlay
'
'#####################################################################################################################

Sub Ntp_get

   Call Clearbuff                                           'Clear the complete buffer   Call Clear_buffer                                        'Clear the complete buffer


      'Mac-header =============

   Buffer(1) = Router_mac(1)                                'MAC of router/gateway
   Buffer(2) = Router_mac(2)
   Buffer(3) = Router_mac(3)
   Buffer(4) = Router_mac(4)
   Buffer(5) = Router_mac(5)
   Buffer(6) = Router_mac(6)

   Call Src2mymac                                           'MAC source address

   Buffer(13) = &H08                                        'DOD IP
   Buffer(14) = &H00

   'IP-header ==============

   Buffer(15) = &H45                                        'header length
   Buffer(16) = &H00                                        'Type of service

   Buffer(17) = &H00                                        'total length
   Buffer(18) = &H4C

   Buffer(19) = &H10                                        'IDentification
   Buffer(20) = &H9B

   Buffer(21) = &H00                                        'flags --> not fragmented

   Buffer(22) = &H00                                        'fragment offset

   Buffer(23) = &H80                                        'TTL

   Buffer(24) = Prot_udp                                    'protocol UDP

   '25 is checksum
   '26 is checksum

   Buffer(27) = Myip(1)                                     'source address  --> MyIP
   Buffer(28) = Myip(2)
   Buffer(29) = Myip(3)
   Buffer(30) = Myip(4)

   Buffer(31) = 192                                         'destination IP --> IP of time-server
   Buffer(32) = 53                                          'PT Bundesanstalt Braunschweig  ntp1.ptb.de
   Buffer(33) = 103
   Buffer(34) = 108

   Buffer(35) = &H00                                        'source port 123
   Buffer(36) = &H7B
   Buffer(37) = &H00                                        'destination port 123 --> ntp server
   Buffer(38) = &H7B
   Buffer(39) = &H00                                        'length
   Buffer(40) = &H38

   '41 is checksum
   '42 is checksum

   Buffer(43) = &B00011011                                  '00 Leap indicator, 011 Version3, 011 Mode=Client

   Call Ip_header_checksum
   Call Udp_checksum
   Call Enc28j60packetsend(90)
End Sub

' Routine to convert the LONG from the NTP-server in to date and time

Sub Ntp
  Swap Buffer(83) , Buffer(86) : Swap Buffer(84) , Buffer(85)
   L2 = L1 + 1139293696
   L2 = L2 + 3600                                           ' offset UTC + 1 hour
   Call Ntp_dst_correction
End Sub


Sub Ntp_dst_correction

'Dont change order of time and date variables !!! This order is required for Date/Time functions used.
Local Second As Byte
Local Minute As Byte
Local Hour As Byte
Local Day As Byte
Local Month As Byte
Local Year As Byte
Local Dow As Byte                                           'Day of week

   Day = Date(l2)                                           'set 3 variables: Day, Month, Year, so Year contains now current year
'DST starts at the last sunday of March, so let's see what weekday the 1st of April is
   Month = 4
   Day = 1
   Hour = 2
   Minute = 0
   Second = 0
   Dow = Dayofweek(day)                                     '0 = Monday to 6 = Sunday
   Day = 31 - Dow                                           'Now count back the days until last sunday
   Month = 3                                                'and set month to March
   If L2 >= Syssec(second) Then
       'DST ends at the last sunday of October, so let's see what weekday the 1st of November is
       Day = 1
       Month = 11
       Dow = Dayofweek(day)                                 '0 = Monday to 6 = Sunday
       Day = 31 - Dow                                       'Now count back the days until last sunday
       Month = 10                                           'and set month to October
       If L2 < Syssec(second) Then
          L2 = L2 + 3600                                    'subtract one hour
'          Print "It's summertime ... one hour added."
       End If
   End If

End Sub