Sub Syncronisation
   ' This code segment processes the incoming SYN from the client
   ' and sends back the initial sequence number (ISN) and acknowledges
   ' the incoming SYN packet
   'Move IP source address to destination address
  T_ip_destaddr = T_ip_srcaddr
   'Make ethernet module IP address source address
  T_ip_srcaddr = My_ip
   'Swap Port
  Call Swapdestport2srcport                                 'Portnummern tauschen
  Tcpdatalen_in = 1
  Client_seqnum0 = Tcp_seqnum0                              'beim 1. mal ist Tcp_seqnum = 0
  Client_seqnum1 = Tcp_seqnum1
  Client_seqnum2 = Tcp_seqnum2
  Client_seqnum3 = Tcp_seqnum3

  Seqnum3 = Tcp_acknum0                                     'empfangener ACK-Wert = 0 als Init-Wert
  Seqnum2 = Tcp_acknum1
  Seqnum1 = Tcp_acknum2
  Seqnum0 = Tcp_acknum3

  Client_seqnum = Client_seqnum + 1                         'Seq+1

' Seqnum_offset = Client_seqnum
  Tcp_acknum0 = Client_seqnum0                              'ack = seq
  Tcp_acknum1 = Client_seqnum1
  Tcp_acknum2 = Client_seqnum2
  Tcp_acknum3 = Client_seqnum3
  Tcp_seqnum0 = &H7F                                        'Initial sequencenumber
  Tcp_seqnum1 = &HFF                                        '
  Tcp_seqnum2 = &H10                                        '
  Tcp_seqnum3 = &H11                                        '
  Call Src2dest                                             'MAC-Adressen im Ethernetheader tauschen
  Call Seq2tcp_seq                                          'Schreibt 0 in SEQ Nummer



 Tcp_res_flag = 1
 For Tempx = 1 To Max_ports                                 'entspricht Anzahl Arrays fr Port und SEQ Nummern
  If Portnummer(tempx) = 0 Then
   Portnummer(tempx) = Buffer(37) * 256
   Portnummer(tempx) = Portnummer(tempx) + Buffer(38)
   Portnum_so(tempx) = Buffer(35) * 256
   Portnum_so(tempx) = Portnum_so(tempx) + Buffer(36)
   Lebenszeit(tempx) = Lebenszeit_sekunden
   Seqnum_offset(tempx) = Seqnum
   Tcp_res_flag = 0
  Exit For
  End If
 Next

 'Seqnum_offset(1) = Seqnum
 Tcp_flags = 0
 Set Tcp_flags.4                                            'ack

 If Tcp_res_flag = 1 Then                                   'maximale Portanzahl erreicht?
  Set Tcp_flags.2                                           'dann sende Reset
 Else
  Set Tcp_flags.1                                           'ansonsten syn
 End If

 T_ip_pktlen0 = &H00
 T_ip_pktlen1 = &H30
 Tcp_hdr = &H70                                             'TCP Header Lnge 7*4=28
 Call Ip_header_checksum
 Call Tcp_checksum
 Call Enc28j60packetsend(62)                                'raus mit
End Sub



Sub Ack_und_seq_behandlung
        Tcp_flags = 0
        'Move IP source address to destination address
        T_ip_destaddr = T_ip_srcaddr
        'Make ethernet module IP address source address
        T_ip_srcaddr = My_ip
        'swap Port
        Call Swapdestport2srcport
        'swap mac
        Call Src2dest                                       'MAC-Adressen im Ethernetheader tauschen
        Call Inc2seq                                        'Eintreffende SEQ Nummer nach Incoming_ack sichern

        T_ip_pktlen = T_ip_pktlen0 * 256                    'Eintreffende Paketlnge zu
        T_ip_pktlen = T_ip_pktlen + T_ip_pktlen1            'eintreffender SEQ-Nummer
        Incoming_ack = Incoming_ack + T_ip_pktlen           'addieren
        Incoming_ack = Incoming_ack - 40                    'Headerlnge abziehen
        Call Seq2ack                                        'Inhalt von eintreffenden ACK nach zu sendenden SEQ schreiben
        Call Ack2inc                                        'zu sendendes ACK schreiben = alte SEQ-Nummer + Paketlnge(oben)
        Buffer(17) = &H00
        Buffer(18) = &H28                                   'IPv4 Header lengh
        '5 x 4 = 20 bytes
        Buffer(47) = &H50                                   'TCP-Header Lnge
        Seqnum3 = Tcp_seqnum0
        Seqnum2 = Tcp_seqnum1
        Seqnum1 = Tcp_seqnum2
        Seqnum0 = Tcp_seqnum3
End Sub


Sub Framebehandlung

End Sub

Sub Tcp_reset
    Local Tempword3 As Word
    Local Pkthulp As Word
    Tempword3 = &H37
        Buffer(36) = Low(portnum_so(tempx))

    'Portnum_so(tempx) = Portnum_so(tempx) / 256
    Buffer(35) = High(portnum_so(tempx))


    Buffer(38) = Low(portnummer(tempx))
    'Portnummer(tempx) = Portnummer(tempx) / 256
    Buffer(37) = High(portnummer(tempx))

    Buffer(42) = Seqnum_offset(tempx)
    Seqnum_offset(tempx) = Seqnum_offset(tempx) / 256
    Buffer(41) = Seqnum_offset(tempx)
    Seqnum_offset(tempx) = Seqnum_offset(tempx) / 256
    Buffer(40) = Seqnum_offset(tempx)
    Seqnum_offset(tempx) = Seqnum_offset(tempx) / 256
    Buffer(39) = Seqnum_offset(tempx)

    Buffer(17) = &H00
    Buffer(18) = &H28

    Set Tcp_flags._ack                                      'ack
    Set Tcp_flags.2                                         'res
    Decr Tempword3
    'Buffer(tempword3) = &H0D
    'Incr Tempword3
    'Buffer(tempword3) = &H0A
    Tempword3 = Tempword3 - 14                              'Ethernet Buffer abziehen
    Pkthulp = Tempword3 / 256                               'Paketlnge ermitteln
    T_ip_pktlen0 = Pkthulp                                  '
    Pkthulp = T_ip_pktlen1 * 256                            '
    T_ip_pktlen1 = Tempword3 - Pkthulp                      '
    Tempword3 = Tempword3 + 14                              'Ethernet Buffer wieder dazu
    Call Ip_header_checksum
    Call Tcp_checksum
    Call Enc28j60packetsend(tempword3)                      'raus mit
End Sub