'********************************* Variablen *********************************
'DMX512
Const Lastchan = 8
Dim Dmxfield(lastchan) As Byte
Dim Newdmxfield(lastchan) As Byte
Dim Dmxsteps(lastchan) As Word
Dim Curdmxsteps(lastchan) As Word
Dim Curdmxch As Word
Dim Dmxstate As Byte
Dim Globalfadeintime As Word
Dim I As Byte
Dim Iw As Word
Dim S As String * 1

'Szenenspeicher (Werte kommen aus dem EEprom)
Dim Scenevalue(lastchan) As Byte
Dim Scenename As String * 6

'Temperatur ber DS18S20
Dim Temperatur As Integer
Dim Halb As Byte

'Helligkeitssensor
Dim Brightness As Word

'RC5 Empfnger
Dim Rc5address As Byte , Rc5command As Byte
Dim Newrc5command As Bit

'Touchscreen / Mensystem
Dim Touchread As Word
Dim Touchx As Word , Touchy As Word
Dim Currentmenu As Byte
Dim Currentfunction As Word
Dim Currentchannel As Word
Dim Lcd_refresh As Bit

'Softclock
Dim L2 As Long
Dim Seconds As Byte

#if Analogclock = 1
   Const Pirad = 3.1415926 / 180                            'use for angle calculation
   Const Bigradius = 58                                     'the biggest circle
   Const Radius = 54                                        'the circle under the biggest use for Railway
   Const Hourradius = 35                                    ' The invisible circle of hours
   Const Minuteradius = 50                                  ' the invisible circle of minutes
   Const Seconderadius = 52                                 ' the invisible circle of seconds
   Const Angle = 90                                         ' 90  mid time
   Const Centrex = 120                                      'center X
   Const Centrey = 64                                       'center Y

   Dim Clocksec As Byte , Clockmin As Byte , Clockhour As Byte

   Dim Startx As Single , Starty As Single , Endy As Single , Endx As Single
   Dim Cosangle As Single , Sinangle As Single , Angle_rad As Single , W As Single
   Dim Clockx As Byte , Clocky As Byte , Ax As Byte , Ay As Byte , J As Byte , K As Integer
   Dim Xseconde As Single , Yseconde As Single

   Declare Sub Drawclock
   Declare Sub Drawsecond(byval Color As Byte , Byval Value As Byte)
   Declare Sub Drawminute(byval Color As Byte , Byval Value As Byte)
   Declare Sub Drawhour(byval Color As Byte , Byval Value As Byte)
#endif

'********************************* Funktionen ********************************
Declare Sub Setdmxch(byval Channel As Word , Byval Startvalue As Byte , Byval Endvalue As Byte , Byval Fadetime As Word)
Declare Sub Stepupch(byval Channel As Word)
Declare Sub Stepdownch(byval Channel As Word)
Declare Sub Readtemp
Declare Sub Readtouch
Declare Sub Proceedrc5
Declare Sub Refreshscreen
Declare Sub Menuaction(byval Col As Byte , Byval Row As Byte)
Declare Sub Savescene(byval Scene As Byte)
Declare Sub Runscene(byval Scene As Byte)
