'********************************* Konstanten ********************************
Const Prot_udp = &H11
Const Prot_icmp = &H01
Const Prot_tcp = &H06

Const Urg = 5
Const _ack = 4
Const Psh = 3
Const Rst = 2
Const Syn = 1
Const Fin = 0
Const Tcp_data = 55


'********************************** Variablen ********************************
'########## Variablen und Deklarationen zur Behandlung der Frames
Declare Sub Tcp_reset
Dim Frameanzahl As Byte
Dim Mesg_zeilen As Byte
'---
Dim Index As Byte
Dim Seqnum_offset(max_ports) As Long
Dim Ack_array(max_ports) As Long
Dim Portnummer(max_ports) As Word
Dim Portnum_so(max_ports) As Word
Dim Lebenszeit(max_ports) As Byte
Dim Dateianfragen(max_ports) As String * 10
Dim Port_zeiger As Byte
Dim Tcp_res_flag As Bit
'---
Dim Tempx As Byte
Dim Temp_e As Word
Dim Temp_l As Long
Dim Framelength As Word
Dim Datenzeiger As Long
Dim Long_str As String * 10
Dim Max_michael_frame As Word
Max_michael_frame = Max_framelen - 4                        'Datenlnge max 1460 (+ &H36 Header +4 Overhead)
Dim Headerlength As Word


'++++++++++++ zum Lesen externer Binr-Dateien ++++++++++++++ (Versuchsstadium)
Dim Size As Word
Dim Zeiger As Word
Dim For_fertig_flag As Bit
Dim Seite_senden As Bit

'DHCP
Dim Lease_time(6) As Byte
Dim Subnetmask(4) As Byte
Dim Broadcast(4) As Byte
Dim Domain_name(7) As Byte
Dim Gateway(4) As Byte
Dim Dhcp_flag As Bit
Dim Router_mac(6) As Byte

'Global DIM's
Dim X As Word
Dim A(5) As Byte
Dim Bank As Byte
Dim Enc28j60_data As Byte
Dim Nextpacketptr As Word
Dim Value As Byte
Dim Wdata As Word
Dim Buffer(max_framelen) As Byte
Dim Length As Word
Dim Rxstat As Word
Dim Ip_id As Word
Dim I_header_length As Word
Dim Seite As Byte
Dim Data_present As Bit

Dim Myip(4) As Byte
Dim My_ip As Long At Myip Overlay
Dim Mymac(6) As Byte

Dim Tempword As Word
Dim Tempwordh As Byte At Tempword + 1 Overlay
Dim Tempwordl As Byte At Tempword Overlay

Dim Tcp_fin As Bit
Dim Tcp_syn As Bit
Dim Tcp_rst As Bit
Dim Tcp_psh As Bit
Dim Tcp_ack As Bit
Dim Tcp_urg As Bit

Dim Synflag As Bit

Dim Packetlength As Word


'Ethernet packet destination
Dim T_enetpacketdest0 As Byte At Buffer Overlay
Dim T_enetpacketdest1 As Byte At Buffer + &H01 Overlay
Dim T_enetpacketdest2 As Byte At Buffer + &H02 Overlay
Dim T_enetpacketdest3 As Byte At Buffer + &H03 Overlay
Dim T_enetpacketdest4 As Byte At Buffer + &H04 Overlay
Dim T_enetpacketdest5 As Byte At Buffer + &H05 Overlay
'Ethernet packet source
Dim T_enetpacketsrc0 As Byte At Buffer + &H06 Overlay
Dim T_enetpacketsrc1 As Byte At Buffer + &H07 Overlay
Dim T_enetpacketsrc2 As Byte At Buffer + &H08 Overlay
Dim T_enetpacketsrc3 As Byte At Buffer + &H09 Overlay
Dim T_enetpacketsrc4 As Byte At Buffer + &H0A Overlay
Dim T_enetpacketsrc5 As Byte At Buffer + &H0B Overlay
'Ethernet packet type
Dim T_enetpackettype As Word At Buffer + &H0C Overlay
Dim T_arp_hwtype1 As Byte At Buffer + &H0F Overlay

'Arp
Dim T_arp_prttype1 As Byte At Buffer + &H11 Overlay
Dim T_arp_hwlen As Byte At Buffer + &H12 Overlay
Dim T_arp_prlen As Byte At Buffer + &H13 Overlay
Dim T_arp_op1 As Byte At Buffer + &H15 Overlay
'arp source ip address
Dim T_arp_sipaddr0 As Byte At Buffer + &H1C Overlay
Dim T_arp_sipaddr1 As Byte At Buffer + &H1D Overlay
Dim T_arp_sipaddr2 As Byte At Buffer + &H1E Overlay
Dim T_arp_sipaddr3 As Byte At Buffer + &H1F Overlay
'arp target IP address
Dim T_arp_tipaddr0 As Byte At Buffer + &H26 Overlay
Dim T_arp_tipaddr1 As Byte At Buffer + &H27 Overlay
Dim T_arp_tipaddr2 As Byte At Buffer + &H28 Overlay
Dim T_arp_tipaddr3 As Byte At Buffer + &H29 Overlay
Dim T_arp_tipaddr As Long At Buffer + &H26 Overlay
'IP header layout IP version and header length
Dim T_ip_vers_len As Byte At Buffer + &H0E Overlay
'Arp
Dim T_arp_prttype0 As Byte At Buffer + &H10 Overlay
Dim T_arp_op0 As Byte At Buffer + &H14 Overlay
'arp source mac address
Dim T_arp_src_enetpacket0 As Byte At Buffer + &H16 Overlay
Dim T_arp_src_enetpacket1 As Byte At Buffer + &H17 Overlay
Dim T_arp_src_enetpacket2 As Byte At Buffer + &H18 Overlay
Dim T_arp_src_enetpacket3 As Byte At Buffer + &H19 Overlay
Dim T_arp_src_enetpacket4 As Byte At Buffer + &H1A Overlay
Dim T_arp_src_enetpacket5 As Byte At Buffer + &H1B Overlay
'arp source mac address
Dim T_arp_dest_enetpacket0 As Byte At Buffer + &H20 Overlay
Dim T_arp_dest_enetpacket1 As Byte At Buffer + &H21 Overlay
Dim T_arp_dest_enetpacket2 As Byte At Buffer + &H22 Overlay
Dim T_arp_dest_enetpacket3 As Byte At Buffer + &H23 Overlay
Dim T_arp_dest_enetpacket4 As Byte At Buffer + &H24 Overlay
Dim T_arp_dest_enetpacket5 As Byte At Buffer + &H25 Overlay
Dim T_tos As Byte At Buffer + &H0F Overlay

'Buffer length
Dim T_ip_pktlen0 As Byte At Buffer + &H10 Overlay           'Byte0->1?
Dim T_ip_pktlen1 As Byte At Buffer + &H11 Overlay           'Byte1->0?
Dim T_ip_pktlen As Word                                     'At Buffer + &H10 Overlay
Dim T_id0 As Byte At Buffer + &H12 Overlay
Dim T_id1 As Byte At Buffer + &H13 Overlay
Dim T_flags As Byte At Buffer + &H14 Overlay
Dim T_offset As Byte At Buffer + &H15 Overlay
Dim T_ttl As Byte At Buffer + &H16 Overlay

'protocol (ICMP=1, TCP=6, UDP=17)
Dim T_ip_proto As Byte At Buffer + &H17 Overlay

'header checksum
Dim T_ip_hdr_cksum0 As Byte At Buffer + &H18 Overlay
Dim T_ip_hdr_cksum1 As Byte At Buffer + &H19 Overlay
Dim T_ip_hdr_cksum As Word At Buffer + &H18 Overlay

'IP address of source
Dim T_ip_srcaddr0 As Byte At Buffer + &H1A Overlay
Dim T_ip_srcaddr1 As Byte At Buffer + &H1B Overlay
Dim T_ip_srcaddr2 As Byte At Buffer + &H1C Overlay
Dim T_ip_srcaddr3 As Byte At Buffer + &H1D Overlay
Dim T_ip_srcaddr As Long At Buffer + &H1A Overlay

'IP address of destination
Dim T_ip_destaddr0 As Byte At Buffer + &H1E Overlay
Dim T_ip_destaddr1 As Byte At Buffer + &H1F Overlay
Dim T_ip_destaddr2 As Byte At Buffer + &H20 Overlay
Dim T_ip_destaddr3 As Byte At Buffer + &H21 Overlay
Dim T_ip_destaddr As Long At Buffer + &H1E Overlay
Dim T_icmp_type As Byte At Buffer + &H22 Overlay
Dim T_icmp_code As Byte At Buffer + &H23 Overlay
Dim T_icmp_cksum0 As Byte At Buffer + &H24 Overlay
Dim T_icmp_cksum1 As Byte At Buffer + &H25 Overlay
Dim T_icmp_cksum As Word At Buffer + &H24 Overlay
Dim Tcp_srcporth As Byte At Buffer + &H22 Overlay
Dim Tcp_srcportl As Byte At Buffer + &H23 Overlay
Dim Tcp_destporth As Byte At Buffer + &H24 Overlay
Dim Tcp_destportl As Byte At Buffer + &H25 Overlay
Dim Tcp_seqnum3 As Byte At Buffer + &H26 Overlay
Dim Tcp_seqnum2 As Byte At Buffer + &H27 Overlay
Dim Tcp_seqnum1 As Byte At Buffer + &H28 Overlay
Dim Tcp_seqnum0 As Byte At Buffer + &H29 Overlay
Dim Tcp_acknum3 As Byte At Buffer + &H2A Overlay
Dim Tcp_acknum2 As Byte At Buffer + &H2B Overlay
Dim Tcp_acknum1 As Byte At Buffer + &H2C Overlay
Dim Tcp_acknum0 As Byte At Buffer + &H2D Overlay
Dim Tcp_hdr As Byte At Buffer + &H2E Overlay
Dim Tcp_flags As Byte At Buffer + &H2F Overlay
Dim Tcp_cksumh As Byte At Buffer + &H32 Overlay
Dim Tcp_cksuml As Byte At Buffer + &H33 Overlay
Dim Tcp_cksum As Word At Buffer + &H32 Overlay

Dim Seqnum As Long
Dim Seqnum3 As Byte At Seqnum Overlay
Dim Seqnum2 As Byte At Seqnum + 1 Overlay
Dim Seqnum1 As Byte At Seqnum + 2 Overlay
Dim Seqnum0 As Byte At Seqnum + 3 Overlay

Dim Acknum As Long
Dim Acknum3 As Byte At Acknum Overlay
Dim Acknum2 As Byte At Acknum + 1 Overlay
Dim Acknum1 As Byte At Acknum + 2 Overlay
Dim Acknum0 As Byte At Acknum + 3 Overlay

'UDP header
Dim T_udp_srcport0 As Byte At Buffer + &H22 Overlay
Dim T_udp_srcport1 As Byte At Buffer + &H23 Overlay
Dim T_udp_srcport As Word At Buffer + &H22 Overlay
Dim T_udp_destport0 As Byte At Buffer + &H24 Overlay
Dim T_udp_destport1 As Byte At Buffer + &H25 Overlay
Dim T_udp_destport As Word At Buffer + &H24 Overlay
Dim T_udp_len0 As Byte At Buffer + &H26 Overlay
Dim T_udp_len1 As Byte At Buffer + &H27 Overlay
Dim T_udp_chksum0 As Byte At Buffer + &H28 Overlay
Dim T_udp_chksum1 As Byte At Buffer + &H29 Overlay
Dim T_udp_chksum As Word At Buffer + &H28 Overlay
Dim T_udp_data(32) As Byte At Buffer + &H2A Overlay

Dim I_chksum32 As Long
Dim I_checksum16 As Word
Dim Result16 As Word
Dim Result16h As Byte At Result16 + 1 Overlay
Dim Result16l As Byte At Result16 Overlay
Dim I_value16 As Word
Dim I_value16h As Byte At I_value16 + 1 Overlay
Dim I_value16l As Byte At I_value16 Overlay
Dim Hulp2 As Word
Dim L As Byte
Dim Dns_name(4) As String * 10

'for DNS-routine
Dim Mydns(4) As Byte

'variables with overlays
Dim Incoming_ack As Long
Dim Incoming_ack0 As Byte At Incoming_ack Overlay
Dim Incoming_ack1 As Byte At Incoming_ack + 1 Overlay
Dim Incoming_ack2 As Byte At Incoming_ack + 2 Overlay
Dim Incoming_ack3 As Byte At Incoming_ack + 3 Overlay

'for NTP-routine
Dim L1 As Long At Buffer(83) Overlay                        'with overlay you need no transfer from the byte-array to a long-variable

'for TCP
Dim Tcpdatalen_in As Word
Dim Flags As Byte

Dim Client_seqnum As Long
Dim Client_seqnum0 As Byte At Client_seqnum Overlay
Dim Client_seqnum1 As Byte At Client_seqnum + 1 Overlay
Dim Client_seqnum2 As Byte At Client_seqnum + 2 Overlay
Dim Client_seqnum3 As Byte At Client_seqnum + 3 Overlay


'********************************* Funktionen ********************************
Declare Sub Enc28j60_reset
Declare Sub Enc28j60_setextclock
Declare Sub Enc28j60_init
Declare Function Enc28j60_version() As Byte
Declare Sub Enc28j60readcontrolregbyte(byval Register As Byte)
Declare Sub Enc28j60writecontrolregbyte(byval Register As Byte , Byval Value As Byte)
Declare Sub Enc28j60selectbank(byval Bank As Byte)
Declare Sub Enc28j60bitfield_set(byval Register As Byte , Byval Value As Byte)
Declare Sub Enc28j60bitfield_clear(byval Register As Byte , Byval Value As Byte)
Declare Sub Enc28j60readphyword(byval Phyregister As Byte)
Declare Sub Enc28j60writephyword(byval Phyregister As Byte , Byval Wdata As Word)
Declare Sub Enc28j60packetsend(byval Pcktlen As Word)
Declare Sub Enc28j60packetreceive
Declare Sub Enc28j60poll
Declare Sub Arpreply
Declare Sub Pingreply
Declare Sub Setip_id
Declare Sub Udp_receive
Declare Sub Udp_checksum
Declare Sub Blinky(byval L As Byte)
Declare Sub Setipaddrs
Declare Sub Tcp
Declare Sub Echopacket
Declare Sub Ip_header_checksum
Declare Sub Icmp_checksum
Declare Sub Http
Declare Sub Tcp_checksum
Declare Sub Src2dest
Declare Sub Inc2seq
Declare Sub Ack2tcp_ack
Declare Sub Seq2tcp_seq
Declare Sub Seq2ack
Declare Sub Ack2inc
Declare Sub Src2mymac
Declare Sub Srcdestchksum
Declare Sub Telnet
Declare Sub Swapsrc2dest
Declare Sub Swapdestport2srcport
Declare Sub Optiona
Declare Sub Optionb
Declare Sub Optionc
Declare Sub Optionquit

Declare Sub Udpreceive

Declare Sub Ntp_get
Declare Sub Ntp
Declare Sub Ntp_dst_correction

Declare Sub Send_dhcp_discover
Declare Sub Clearbuff
Declare Sub Dhcp_request
Declare Sub Dhcp
Declare Sub Dhcp_lease
Declare Sub Dhcp_received_newip

Declare Sub Syncronisation
Declare Sub Framebehandlung
Declare Sub Ack_und_seq_behandlung
